FixedSizeAlignedSecBlock< T, S, T_Align16 > Class Template Reference

Fixed size stack-based SecBlock with 16-byte alignment. More...

Inheritance diagram for FixedSizeAlignedSecBlock< T, S, T_Align16 >:

## Additional Inherited Members

Public Types inherited from SecBlock< T, FixedSizeAllocatorWithCleanup< T, S, NullAllocator< T >, T_Align16 > >
typedef FixedSizeAllocatorWithCleanup< T, S, NullAllocator< T >, T_Align16 > ::value_type | value_type
typedef FixedSizeAllocatorWithCleanup< T, S, NullAllocator< T >, T_Align16 > ::pointer | iterator
typedef FixedSizeAllocatorWithCleanup< T, S, NullAllocator< T >, T_Align16 > ::const_pointer | const_iterator
typedef FixedSizeAllocatorWithCleanup< T, S, NullAllocator< T >, T_Align16 > ::size_type | size_type
Public Member Functions inherited from FixedSizeSecBlock< T, S, FixedSizeAllocatorWithCleanup< T, S, NullAllocator< T >, T_Align16 > >
| FixedSizeSecBlock ()
| Construct a FixedSizeSecBlock.
Public Member Functions inherited from SecBlock< T, FixedSizeAllocatorWithCleanup< T, S, NullAllocator< T >, T_Align16 > >
| SecBlock (size_type size=0)
| Construct a SecBlock with space for size elements. More...
| SecBlock (const SecBlock< T, FixedSizeAllocatorWithCleanup< T, S, NullAllocator< T >, T_Align16 > > &t)
| Copy construct a SecBlock from another SecBlock. More...
| SecBlock (const T *ptr, size_type len)
| Construct a SecBlock from an array of elements. More...
| operator const void * () const
| operator void * ()
| operator const T * () const
| operator T* ()
iterator | begin ()
| Provides an iterator pointing to the first element in the memory block. More...
const_iterator | begin () const
| Provides a constant iterator pointing to the first element in the memory block. More...
iterator | end ()
| Provides an iterator pointing beyond the last element in the memory block. More...
const_iterator | end () const
| Provides a constant iterator pointing beyond the last element in the memory block. More...
FixedSizeAllocatorWithCleanup< T, S, NullAllocator< T >, T_Align16 > ::pointer | data ()
| Provides a pointer to the first element in the memory block. More...
FixedSizeAllocatorWithCleanup< T, S, NullAllocator< T >, T_Align16 > ::const_pointer | data () const
| Provides a pointer to the first element in the memory block. More...
size_type | size () const
| Provides the count of elements in the SecBlock. More...
bool | empty () const
| Determines if the SecBlock is empty. More...
byte * | BytePtr ()
| Provides a byte pointer to the first element in the memory block. More...
const byte * | BytePtr () const
| Return a byte pointer to the first element in the memory block. More...
size_type | SizeInBytes () const
| Provides the number of bytes in the SecBlock. More...
void | Assign (const T *ptr, size_type len)
| Set contents and size from an array. More...
void | Assign (const SecBlock< T, FixedSizeAllocatorWithCleanup< T, S, NullAllocator< T >, T_Align16 > > &t)
| Copy contents from another SecBlock. More...
SecBlock< T, FixedSizeAllocatorWithCleanup< T, S, NullAllocator< T >, T_Align16 > > & | operator= (const SecBlock< T, FixedSizeAllocatorWithCleanup< T, S, NullAllocator< T >, T_Align16 > > &t)
| Assign contents from another SecBlock. More...
SecBlock< T, FixedSizeAllocatorWithCleanup< T, S, NullAllocator< T >, T_Align16 > > & | operator+= (const SecBlock< T, FixedSizeAllocatorWithCleanup< T, S, NullAllocator< T >, T_Align16 > > &t)
| Append contents from another SecBlock. More...
SecBlock< T, FixedSizeAllocatorWithCleanup< T, S, NullAllocator< T >, T_Align16 > > | operator+ (const SecBlock< T, FixedSizeAllocatorWithCleanup< T, S, NullAllocator< T >, T_Align16 > > &t)
| Construct a SecBlock from this and another SecBlock. More...
bool | operator== (const SecBlock< T, FixedSizeAllocatorWithCleanup< T, S, NullAllocator< T >, T_Align16 > > &t) const
| Bitwise compare two SecBlocks. More...
bool | operator!= (const SecBlock< T, FixedSizeAllocatorWithCleanup< T, S, NullAllocator< T >, T_Align16 > > &t) const
| Bitwise compare two SecBlocks. More...
void | New (size_type newSize)
| Change size without preserving contents. More...
void | CleanNew (size_type newSize)
| Change size without preserving contents. More...
void | Grow (size_type newSize)
| Change size and preserve contents. More...
void | CleanGrow (size_type newSize)
| Change size and preserve contents. More...
void | resize (size_type newSize)
| Change size and preserve contents. More...
void | swap (SecBlock< T, FixedSizeAllocatorWithCleanup< T, S, NullAllocator< T >, T_Align16 > > &b)
| Swap contents with another SecBlock. More...
Public Attributes inherited from SecBlock< T, FixedSizeAllocatorWithCleanup< T, S, NullAllocator< T >, T_Align16 > >
FixedSizeAllocatorWithCleanup< T, S, NullAllocator< T >, T_Align16 > | m_alloc
size_type | m_size
T * | m_ptr

## Detailed Description

### template<class T, unsigned int S, bool T_Align16 = true>
class FixedSizeAlignedSecBlock< T, S, T_Align16 >

Fixed size stack-based SecBlock with 16-byte alignment.

Template Parameters

  T | class or type
  S | fixed-size of the stack-based memory block, in elements
  A | AllocatorBase derived class for allocation and cleanup

Definition at line 766 of file secblock.h.

The documentation for this class was generated from the following file:

- secblock.h